package CelBot::Connector;

use strict;

use Carp;

sub connect
{
   my %args = @_;

   my $loop = $args{loop};

   # Callbacks
   my $on_connected     = $args{on_connected}     or croak "Expected 'on_connected' callback";
   my $on_connect_error = $args{on_connect_error} or croak "Expected 'on_connect_error' callback";
   my $on_resolve_error = $args{on_resolve_error} or croak "Expected 'on_resolve_error' callback";

   my $on_fail;
   $on_fail = sub { eval { $args{on_fail}->( @_ ) } or
                       ::console_print_err( "on_fail callback failed - $@\n" ) } if $args{on_fail};

   $loop->connect(
      host => $args{host},
      service => $args{service},

      on_connected     => sub { eval { $on_connected->( @_ ); 1 } or
                                   ::console_print_err( "on_connected callback failed - $@\n" ) },
      on_connect_error => sub { eval { $on_connect_error->( @_ ); 1 } or
                                   ::console_print_err( "on_connect_error callback failed - $@\n" ) },
      on_resolve_error => sub { eval { $on_resolve_error->( @_ ); 1 } or
                                   ::console_print_err( "on_resolve_error callback failed - $@\n" ) },

      on_fail => $on_fail,
   );
}

# Keep perl happy; keep Britain tidy
1;
