package CelBot::Plugin::Messages;

use strict;
use constant PLUGIN_TYPE => "messages";

sub new
{
   my $class = shift;
   my ( $core, $config ) = @_;

   my $self = bless {
      core => $core,
   }, $class;

   return $self;
}

sub on_message
{
   my $self = shift;
   my ( $command, $message, $hints ) = @_;

   my @args    = $message->args;

   # Eat any of the server stats or MOTD messages
   # 301 == "away"
   return 1 if grep { $command eq $_ }
      qw(
         002 003 004
         250 251 252 254 255 265 266
         301
         372 375 376
      );

   return 1 if $command eq "NOTICE" and $args[0] eq "AUTH";

   # Suppress ctcp ACTIONs from debugging log
   return 1 if $command eq "ctcp ACTION";

   return 0;
}

# Keep perl happy, keep Britain tidy
1;
