package CelBot::Plugin::OpReport;

use strict;
use constant PLUGIN_TYPE => "opreport";

sub new
{
   my $class = shift;
   my ( $core, $config ) = @_;

   my $self = bless {
      core => $core,
      irc  => $core->get_plugin( "irc" ),
   }, $class;

   return $self;
}

###
# Commands
###

sub register_commands
{
   my $self = shift;
   my ( $commands_plugin ) = @_;

   $commands_plugin->register(
      plugin  => $self,
      command => "opreport",
      perm    => 'master',

      args => [],

      summary => "Report on my channel status in all channels",
   );
}

sub command_opreport
{
   my $self = shift;

   my $irc = $self->{irc};
   my @channels = $irc->get_channels_plugin->get_channels;

   my $me = $irc->get_user_me;

   my @chanflags;

   foreach my $channel ( sort { $a->name cmp $b->name } @channels ) {
      my $myflag = $channel->get_userflag( $me );
      push @chanflags, $myflag . $channel->name;
   }

   return "Channels: " . join( " ", @chanflags );
}

# Keep perl happy, keep Britain tidy
1;
