package CelBot::Resolver;

use strict;

sub resolve
{
   my %args = @_;

   my $loop = $args{loop};

   my $on_resolved = delete $args{on_resolved};
   my $on_error    = delete $args{on_error};

   $loop->resolve(
      type => $args{type},
      data => $args{data},

      on_resolved => sub {
         my @data = @_;

         my $ret = eval { $on_resolved->( @data ); 1 };

         if( !defined $ret and $@ ) {
            ::console_print_err( "Callback on_resolved failed - $@\n" );
         }
      },

      on_error  => sub {
         my ( $err ) = @_;

         chomp $err;

         my $ret = eval { $on_error->( $err ); 1 };

         if( !defined $ret and $@ ) {
            ::console_print_err( "Callback on_error failed - $@\n" );
         }
      },
   );
}

# Keep perl happy; keep Britain tidy
1;
